-- PSPInstaller is coded by Richard Sparrow (AKA Spike_132000)
-- No reproduction of this code may be used without permission

arial = pge.font.load("S/ARIAL.TTF", 12, PGE_RAM)

img_brow = pge.texture.load("S/BROW.PNG")
img_sett = pge.texture.load("S/SETT.PNG")
img_sear = pge.texture.load("S/SEAR.PNG")
img_exit = pge.texture.load("S/EXIT.PNG")
img_down = pge.texture.load("S/DOWN.PNG")
img_logo = pge.texture.load("S/LOGO.PNG")

white = pge.gfx.createcolor(255,255,255)
red  = pge.gfx.createcolor(255,0,0)
state = -1

pge.net.init()
pge.utils.netinit()

while pge.running() do
	pge.gfx.startdrawing()
	pge.gfx.clearscreen()
	img_down:activate()
	img_down:draweasy(0,0)
	arial:activate()
	arial:print(10, 40,white, "Loading...")

	pge.gfx.enddrawing()
	state = pge.utils.netupdate()
	if state == 0 then
		break
	elseif state == 1 then
		pge.net.shutdown()
		break
	elseif state ~= PGE_UTILS_DIALOG_RUNNING then
		pge.net.shutdown()
		break
	end
	pge.gfx.swapbuffers()
	
end

src_list_opt = 1
src_topi_opt = 1
src_curr_opt = 1
gam_list_opt = 1	
gam_topi_opt = 1
app_list_opt = 1
app_topi_opt = 1
the_list_opt = 1
the_topi_opt = 1
oth_list_opt = 1
oth_topi_opt = 1
bro_list_opt = 1

dofile("INI.LUA")
if psp_inst_host == "" then
	error("INI.LUA is missing or damaged!")
end
dofile("SOURCELIST.LUA")

state=1

while pge.running() do
	pge.controls.update()
	pge.gfx.startdrawing()
	pge.gfx.clearscreen()
	
	if state == 1 then
		img_sett:activate()
		img_sett:draweasy(0,0)
		arial:activate()
		arial:print(120,55,white,"Welcome to PSP Installer Version 2.00")
		arial:print(120,70,white,"Use L Trigger and R Trigger to navigate between tabs.")
		arial:print(120,85,white,"Use D-Pad to navigate within tabs.")
		arial:print(147,125,white,"Download Sourcelist")
		arial:print(120,160,white,"Thanks go to : dan369, cmbeke, kartracer12, PL3x, _df_,")
		arial:print(120,175,white,"pspuser1690, Anonymous Blah, Joomla12, Red X, psphkkr4u15,")
		arial:print(120,190,white,"conrados1, Hurarah, cluth1215, ibby123456789, yammata684,")
		arial:print(120,205,white,"Bolt, leo9891 and GMT for their help and comments!")

		pge.gfx.drawrectoutline(128, 115, 300, 30, white)
		pge.gfx.drawrect(129,116,3,29,red)
		if pge.controls.pressed(PGE_CTRL_CROSS) then
				pge.gfx.startdrawing()
				pge.gfx.clearscreen()
				
				img_down:activate()
				img_down:draweasy(0,0)
				arial:activate()
				arial:print(10, 40,white, "Updating Sourcelist and Downloading Repositories...")
				arial:print(10, 55,white, "Please Wait...")
				pge.gfx.enddrawing()
				pge.gfx.swapbuffers()
			while pge.running() do
				pge.controls.update()
				pge.gfx.startdrawing()
				pge.gfx.clearscreen()
				img_down:activate()
				img_down:draweasy(0,0)
				dofile("SOURCELIST.LUA")
				check=1
				while srclist[check] do
					if pge.net.isconnected() then
						pge.file.remove(srclist[check].hf)
						check=check+1
					end
				end
				pge.file.remove("SOURCELIST.LUA")					
				if pge.net.isconnected() then
					
					pge.net.getfile(psp_inst_host,"SOURCELIST.LUA")
				end
				dofile("SOURCELIST.LUA")	
				check=1
				while srclist[check] do
					if pge.net.isconnected() then
						pge.net.getfile(srclist[check].hd,srclist[check].hf)
						check=check+1
					end
				end
				if pge.net.isconnected() then
					arial:activate()
					arial:print(10,40,white, "Updated Sourcelist and Repositories!.")
					arial:print(10,55,white, "Press Start to return.")
				else
					arial:activate()
					arial:print(10,40,white, "Updating Sourcelist Failed. Make sure Wireless is Connected.")
					arial:print(10,55,white, "Press Start to return.")
				end
				pge.gfx.enddrawing()
				pge.gfx.swapbuffers()
				
				while not pge.controls.pressed(PGE_CTRL_START) do
					pge.controls.update()
				end
				break
			end
		end

		if pge.controls.pressed(PGE_CTRL_RTRIGGER) then
			state=2
		end

	end

	if state == 2 then
		img_brow:activate()
		img_brow:draweasy(0,0)
		arial:activate()
		arial:print(132,55,white,srclist[src_list_opt].ho)
		arial:print(132,70,white,srclist[src_list_opt].ha)
		pge.gfx.drawrectoutline(124, 50, 336, 48, white)
		if srclist[src_list_opt+1] then
			arial:print(132,103,white,srclist[src_list_opt+1].ho)
			arial:print(132,118,white,srclist[src_list_opt+1].ha)
			pge.gfx.drawrectoutline(124, 98, 336, 48, white)
		end
		if srclist[src_list_opt+2] then
			arial:print(132,151,white,srclist[src_list_opt+2].ho)
			arial:print(132,166,white,srclist[src_list_opt+2].ha)
			pge.gfx.drawrectoutline(124, 146, 336, 48, white)
		end
		if srclist[src_list_opt+3] then
			arial:print(132,199,white,srclist[src_list_opt+3].ho)
			arial:print(132,214,white,srclist[src_list_opt+3].ha)
			pge.gfx.drawrectoutline(124, 194, 336, 48, white)
		end			
		if src_topi_opt==1 then
			pge.gfx.drawrect(125,51,5,47,red)
		end
		if src_topi_opt==2 then
			pge.gfx.drawrect(125,99,5,47,red)
		end
		if src_topi_opt==3 then
			pge.gfx.drawrect(125,147,5,47,red)
		end
		if src_topi_opt==4 then
			pge.gfx.drawrect(125,195,5,47,red)
		end
		cur_src_sel = src_list_opt + src_topi_opt - 1
		if pge.controls.pressed(PGE_CTRL_DOWN) then
			
			if cur_src_sel == src_list_max then
			else
				if src_topi_opt > 3 then
					src_list_opt = src_list_opt + 1
					src_topi_opt = 4
					if src_list_opt == src_list_max+1 then
						src_list_opt = src_list_max
						
					end
				elseif src_topi_opt < 4 then
					src_topi_opt = src_topi_opt + 1
				end
			end
		end
		if pge.controls.pressed(PGE_CTRL_UP) then 
			
			if src_topi_opt < 2 then
				src_list_opt = src_list_opt - 1
				src_topi_opt = 1
				if src_list_opt == 0 then
					src_list_opt = 1
				end	
			elseif src_topi_opt > 1 then
				src_topi_opt = src_topi_opt - 1
			end
		end
 
		if pge.controls.pressed(PGE_CTRL_CROSS) then
			cur_src_use = src_list_opt + src_topi_opt - 1
			gam_list_opt = 1
			gam_topi_opt = 1	
			app_list_opt = 1
			app_topi_opt = 1
			the_list_opt = 1
			the_topi_opt = 1
			oth_list_opt = 1
			oth_topi_opt = 1
			bro_list_opt = 1
			cur_gam_sel = 1
			cur_app_sel = 1
			cur_the_sel = 1
			cur_oth_sel = 1
			dofile(srclist[cur_src_use].hf)
			state=21
	
		end
		if pge.controls.pressed(PGE_CTRL_LTRIGGER) then
			state=1
		end
		if pge.controls.pressed(PGE_CTRL_RTRIGGER) then
			state=3
		end

			
	end
	
	if state == 21 then
		img_brow:activate()
		img_brow:draweasy(0,0)
		arial:activate()
		arial:print(132,70,white,"Games")
		arial:print(132,118,white,"Applications")
		arial:print(132,166,white,"Themes")
		arial:print(132,214,white,"Saves, Plugins, Other")
		pge.gfx.drawrectoutline(124, 50, 336, 48, white)
		pge.gfx.drawrectoutline(124, 98, 336, 48, white)
		pge.gfx.drawrectoutline(124, 146, 336, 48, white)
		pge.gfx.drawrectoutline(124, 194, 336, 48, white)

		if pge.controls.pressed(PGE_CTRL_DOWN) then	
			bro_list_opt = bro_list_opt + 1
			if bro_list_opt > 4 then
				bro_list_opt = 1
			end
		end
		if pge.controls.pressed(PGE_CTRL_UP) then	
			bro_list_opt = bro_list_opt - 1
			if bro_list_opt < 1 then
				bro_list_opt = 4
			end
		end
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			state=2
		end

		if bro_list_opt == 1 then
			pge.gfx.drawrect(125,51,5,47,red)
			if pge.controls.pressed(PGE_CTRL_CROSS) then
				state=22		
			end
		end
		if bro_list_opt == 2 then
			pge.gfx.drawrect(125,99,5,47,red)
			if pge.controls.pressed(PGE_CTRL_CROSS) then
				state=23
			end
		end
		if bro_list_opt == 3 then
			pge.gfx.drawrect(125,147,5,47,red)
			if pge.controls.pressed(PGE_CTRL_CROSS) then
				state=24
			end
		end
		if bro_list_opt == 4 then
			pge.gfx.drawrect(125,195,5,47,red)
			if pge.controls.pressed(PGE_CTRL_CROSS) then
				state=25
			end
		end
		if pge.controls.pressed(PGE_CTRL_LTRIGGER) then
			state=1
		end
		if pge.controls.pressed(PGE_CTRL_RTRIGGER) then
			state=3
		end

	end





	if state == 22 then
		if not gamlist[1] then
			state=21
		end
		img_brow:activate()
		img_brow:draweasy(0,0)
		arial:activate()
		if gamlist[gam_list_opt] then
			arial:print(132,55,white,gamlist[gam_list_opt].n)
			arial:print(132,70,white,gamlist[gam_list_opt].d)
			pge.gfx.drawrectoutline(124, 50, 336, 48, white)
		end
		if gamlist[gam_list_opt+1] then
			arial:print(132,103,white,gamlist[gam_list_opt+1].n)
			arial:print(132,118,white,gamlist[gam_list_opt+1].d)
			pge.gfx.drawrectoutline(124, 98, 336, 48, white)
		end
		if gamlist[gam_list_opt+2] then
			arial:print(132,151,white,gamlist[gam_list_opt+2].n)
			arial:print(132,166,white,gamlist[gam_list_opt+2].d)
			pge.gfx.drawrectoutline(124, 146, 336, 48, white)
		end
		if gamlist[gam_list_opt+3] then
			arial:print(132,199,white,gamlist[gam_list_opt+3].n)
			arial:print(132,214,white,gamlist[gam_list_opt+3].d)
			pge.gfx.drawrectoutline(124, 194, 336, 48, white)
		end			
		
		if gam_topi_opt==1 then
			pge.gfx.drawrect(125,51,5,47,red)
		end
		if gam_topi_opt==2 then
			pge.gfx.drawrect(125,99,5,47,red)
		end
		if gam_topi_opt==3 then
			pge.gfx.drawrect(125,147,5,47,red)
		end
		if gam_topi_opt==4 then
			pge.gfx.drawrect(125,195,5,47,red)
		end
		cur_gam_sel = gam_list_opt + gam_topi_opt - 1
		if pge.controls.pressed(PGE_CTRL_DOWN) then
			if cur_gam_sel == gam_list_max then
			else
				if gam_topi_opt > 3 then
					gam_list_opt = gam_list_opt + 1
					gam_topi_opt = 4
					if gam_list_opt == gam_list_max+1 then
						gam_list_opt = gam_list_max
						
					end
				elseif gam_topi_opt < 4 then
					gam_topi_opt = gam_topi_opt + 1
				end
			end
		end
		if pge.controls.pressed(PGE_CTRL_UP) then 
			if gam_topi_opt < 2 then
				gam_list_opt = gam_list_opt - 1
				gam_topi_opt = 1
				if gam_list_opt == 0 then
					gam_list_opt = 1
				end	
			elseif gam_topi_opt > 1 then
				gam_topi_opt = gam_topi_opt - 1
			end
		end
		if pge.controls.pressed(PGE_CTRL_CROSS) then
				pge.gfx.startdrawing()
				pge.gfx.clearscreen()
				
				img_down:activate()
				img_down:draweasy(0,0)
				arial:activate()
				arial:print(10, 40,white, "Downloading and Unzipping "..gamlist[cur_gam_sel].f.."...")
				arial:print(10, 55,white, "This may take a while. Please Wait!")
				pge.gfx.enddrawing()
				pge.gfx.swapbuffers()
			if pge.net.isconnected() then			
				pge.net.getfile(gam_repo_url.."/"..gamlist[cur_gam_sel].f,"ms0:/"..gamlist[cur_gam_sel].f)
				pge.gfx.startdrawing()
				pge.gfx.clearscreen()
				
				img_down:activate()
				img_down:draweasy(0,0)
				arial:activate()
				arial:print(10, 40,white, gamlist[cur_gam_sel].n.." is installed!")
				arial:print(10, 55,white, "Press Start to Return")

				
				currentwd = pge.dir.getcwd()
				myzipfile = pge.zip.open("ms0:/"..gamlist[cur_gam_sel].f)
				pge.dir.chdir("ms0:/")
				myzipfile:extract()
				pge.zip.close(myzipfile)
				myzipfile = nil
									
				pge.dir.chdir(currentwd)
				collectgarbage("collect")
				pge.gfx.enddrawing()
				pge.gfx.swapbuffers()
						
			end
			while not pge.controls.pressed(PGE_CTRL_START) do
				pge.controls.update()
			end
		end
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			state=21
		end
		if pge.controls.pressed(PGE_CTRL_LTRIGGER) then
			state=1
		end
		if pge.controls.pressed(PGE_CTRL_RTRIGGER) then
			state=3
		end

	end
	
	if state == 23 then
		if not applist[1] then
			state=21
		end
		img_brow:activate()
		img_brow:draweasy(0,0)
		arial:activate()
		if applist[app_list_opt] then
			arial:print(132,55,white,applist[app_list_opt].n)
			arial:print(132,70,white,applist[app_list_opt].d)
			pge.gfx.drawrectoutline(124, 50, 336, 48, white)
		end
		if applist[app_list_opt+1] then
			arial:print(132,103,white,applist[app_list_opt+1].n)
			arial:print(132,118,white,applist[app_list_opt+1].d)
			pge.gfx.drawrectoutline(124, 98, 336, 48, white)
		end
		if applist[app_list_opt+2] then
			arial:print(132,151,white,applist[app_list_opt+2].n)
			arial:print(132,166,white,applist[app_list_opt+2].d)
			pge.gfx.drawrectoutline(124, 146, 336, 48, white)
		end
		if applist[app_list_opt+3] then
			arial:print(132,199,white,applist[app_list_opt+3].n)
			arial:print(132,214,white,applist[app_list_opt+3].d)
			pge.gfx.drawrectoutline(124, 194, 336, 48, white)
		end			
		
		if app_topi_opt==1 then
			pge.gfx.drawrect(125,51,5,47,red)
		end
		if app_topi_opt==2 then
			pge.gfx.drawrect(125,99,5,47,red)
		end
		if app_topi_opt==3 then
			pge.gfx.drawrect(125,147,5,47,red)
		end
		if app_topi_opt==4 then
			pge.gfx.drawrect(125,195,5,47,red)
		end
		cur_app_sel = app_list_opt + app_topi_opt - 1
		if pge.controls.pressed(PGE_CTRL_DOWN) then
			if cur_app_sel == app_list_max then
			else
				if app_topi_opt > 3 then
					app_list_opt = app_list_opt + 1
					app_topi_opt = 4
					if app_list_opt == app_list_max+1 then
						app_list_opt = app_list_max
						
					end
				elseif app_topi_opt < 4 then
					app_topi_opt = app_topi_opt + 1
				end
			end
		end
		if pge.controls.pressed(PGE_CTRL_UP) then 
			if app_topi_opt < 2 then
				app_list_opt = app_list_opt - 1
				app_topi_opt = 1
				if app_list_opt == 0 then
					app_list_opt = 1
				end	
			elseif app_topi_opt > 1 then
				app_topi_opt = app_topi_opt - 1
			end
		end
		if pge.controls.pressed(PGE_CTRL_CROSS) then
				pge.gfx.startdrawing()
				pge.gfx.clearscreen()
				
				img_down:activate()
				img_down:draweasy(0,0)
				arial:activate()
				arial:print(10, 40,white, "Downloading and Unzipping "..applist[cur_app_sel].f.."...")
				arial:print(10, 55,white, "This may take a while. Please Wait!")
				pge.gfx.enddrawing()
				pge.gfx.swapbuffers()
			if pge.net.isconnected() then			
				pge.net.getfile(app_repo_url.."/"..applist[cur_app_sel].f,"ms0:/"..applist[cur_app_sel].f)
				pge.gfx.startdrawing()
				pge.gfx.clearscreen()
				
				img_down:activate()
				img_down:draweasy(0,0)
				arial:activate()
				arial:print(10, 40,white, applist[cur_app_sel].n.." is installed!")
				arial:print(10, 55,white, "Press Start to Return")

				
				currentwd = pge.dir.getcwd()
				myzipfile = pge.zip.open("ms0:/"..applist[cur_app_sel].f)
				pge.dir.chdir("ms0:/")
				myzipfile:extract()
				pge.zip.close(myzipfile)
				myzipfile = nil
									
				pge.dir.chdir(currentwd)
				collectgarbage("collect")
				pge.gfx.enddrawing()
				pge.gfx.swapbuffers()
						
			end
			while not pge.controls.pressed(PGE_CTRL_START) do
				pge.controls.update()
			end
		end

		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			state=21
		end
		if pge.controls.pressed(PGE_CTRL_LTRIGGER) then
			state=1
		end
		if pge.controls.pressed(PGE_CTRL_RTRIGGER) then
			state=3
		end


	end
	
	if state == 24 then
		if not thelist[1] then
			state=21
		end
		img_brow:activate()
		img_brow:draweasy(0,0)
		arial:activate()
		if thelist[the_list_opt] then
			arial:print(132,55,white,thelist[the_list_opt].n)
			arial:print(132,70,white,thelist[the_list_opt].d)
			pge.gfx.drawrectoutline(124, 50, 336, 48, white)
		end
		if thelist[the_list_opt+1] then
			arial:print(132,103,white,thelist[the_list_opt+1].n)
			arial:print(132,118,white,thelist[the_list_opt+1].d)
			pge.gfx.drawrectoutline(124, 98, 336, 48, white)
		end
		if thelist[the_list_opt+2] then
			arial:print(132,151,white,thelist[the_list_opt+2].n)
			arial:print(132,166,white,thelist[the_list_opt+2].d)
			pge.gfx.drawrectoutline(124, 146, 336, 48, white)
		end
		if thelist[the_list_opt+3] then
			arial:print(132,199,white,thelist[the_list_opt+3].n)
			arial:print(132,214,white,thelist[the_list_opt+3].d)
			pge.gfx.drawrectoutline(124, 194, 336, 48, white)
		end			
		
		if the_topi_opt==1 then
			pge.gfx.drawrect(125,51,5,47,red)
		end
		if the_topi_opt==2 then
			pge.gfx.drawrect(125,99,5,47,red)
		end
		if the_topi_opt==3 then
			pge.gfx.drawrect(125,147,5,47,red)
		end
		if the_topi_opt==4 then
			pge.gfx.drawrect(125,195,5,47,red)
		end
		cur_the_sel = the_list_opt + the_topi_opt - 1
		if pge.controls.pressed(PGE_CTRL_DOWN) then
			if cur_the_sel == the_list_max then
			else
				if the_topi_opt > 3 then
					the_list_opt = the_list_opt + 1
					the_topi_opt = 4
					if the_list_opt == the_list_max+1 then
						the_list_opt = the_list_max
						
					end
				elseif the_topi_opt < 4 then
					the_topi_opt = the_topi_opt + 1
				end
			end
		end
		if pge.controls.pressed(PGE_CTRL_UP) then 
			if the_topi_opt < 2 then
				the_list_opt = the_list_opt - 1
				the_topi_opt = 1
				if the_list_opt == 0 then
					the_list_opt = 1
				end	
			elseif the_topi_opt > 1 then
				the_topi_opt = the_topi_opt - 1
			end
		end
		if pge.controls.pressed(PGE_CTRL_CROSS) then
				pge.gfx.startdrawing()
				pge.gfx.clearscreen()
				
				img_down:activate()
				img_down:draweasy(0,0)
				arial:activate()
				arial:print(10, 40,white, "Downloading and Unzipping "..thelist[cur_the_sel].f.."...")
				arial:print(10, 55,white, "This may take a while. Please Wait!")
				pge.gfx.enddrawing()
				pge.gfx.swapbuffers()	
			if pge.net.isconnected() then			
				pge.net.getfile(the_repo_url.."/"..thelist[cur_the_sel].f,"ms0:/"..thelist[cur_the_sel].f)
				pge.gfx.startdrawing()
				pge.gfx.clearscreen()
				
				img_down:activate()
				img_down:draweasy(0,0)
				arial:activate()
				arial:print(10, 40,white, thelist[cur_the_sel].f.." is installed!")
				arial:print(10, 55,white, "Press Start to Return")

				
				currentwd = pge.dir.getcwd()
				myzipfile = pge.zip.open("ms0:/"..thelist[cur_the_sel].f)
				pge.dir.chdir("ms0:/")
				myzipfile:extract()
				pge.zip.close(myzipfile)
				myzipfile = nil
									
				pge.dir.chdir(currentwd)
				collectgarbage("collect")
				pge.gfx.enddrawing()
				pge.gfx.swapbuffers()
						
			end
			while not pge.controls.pressed(PGE_CTRL_START) do
				pge.controls.update()
			end
		end

		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			state=21
		end
		if pge.controls.pressed(PGE_CTRL_LTRIGGER) then
			state=1
		end
		if pge.controls.pressed(PGE_CTRL_RTRIGGER) then
			state=3
		end



	end

	if state == 25 then
		if not othlist[1] then
			state=21
		end
		img_brow:activate()
		img_brow:draweasy(0,0)
		arial:activate()
		if othlist[oth_list_opt] then
			arial:print(132,55,white,othlist[oth_list_opt].n)
			arial:print(132,70,white,othlist[oth_list_opt].d)
			pge.gfx.drawrectoutline(124, 50, 336, 48, white)
		end
		if othlist[oth_list_opt+1] then
			arial:print(132,103,white,othlist[oth_list_opt+1].n)
			arial:print(132,118,white,othlist[oth_list_opt+1].d)
			pge.gfx.drawrectoutline(124, 98, 336, 48, white)
		end
		if othlist[oth_list_opt+2] then
			arial:print(132,151,white,othlist[oth_list_opt+2].n)
			arial:print(132,166,white,othlist[oth_list_opt+2].d)
			pge.gfx.drawrectoutline(124, 146, 336, 48, white)
		end
		if othlist[oth_list_opt+3] then
			arial:print(132,199,white,othlist[oth_list_opt+3].n)
			arial:print(132,214,white,othlist[oth_list_opt+3].d)
			pge.gfx.drawrectoutline(124, 194, 336, 48, white)
		end			
		
		if oth_topi_opt==1 then
			pge.gfx.drawrect(125,51,5,47,red)
		end
		if oth_topi_opt==2 then
			pge.gfx.drawrect(125,99,5,47,red)
		end
		if oth_topi_opt==3 then
			pge.gfx.drawrect(125,147,5,47,red)
		end
		if oth_topi_opt==4 then
			pge.gfx.drawrect(125,195,5,47,red)
		end
		cur_oth_sel = oth_list_opt + oth_topi_opt - 1
		if pge.controls.pressed(PGE_CTRL_DOWN) then
			if cur_oth_sel == oth_list_max then
			else
				if oth_topi_opt > 3 then
					oth_list_opt = oth_list_opt + 1
					oth_topi_opt = 4
					if oth_list_opt == oth_list_max+1 then
						oth_list_opt = oth_list_max
						
					end
				elseif oth_topi_opt < 4 then
					oth_topi_opt = oth_topi_opt + 1
				end
			end
		end
		if pge.controls.pressed(PGE_CTRL_UP) then 
			if oth_topi_opt < 2 then
				oth_list_opt = oth_list_opt - 1
				oth_topi_opt = 1
				if oth_list_opt == 0 then
					oth_list_opt = 1
				end	
			elseif oth_topi_opt > 1 then
				oth_topi_opt = oth_topi_opt - 1
			end
		end
		if pge.controls.pressed(PGE_CTRL_CROSS) then
				pge.gfx.startdrawing()
				pge.gfx.clearscreen()
				
				img_down:activate()
				img_down:draweasy(0,0)
				arial:activate()
				arial:print(10, 40,white, "Downloading and Unzipping "..othlist[cur_oth_sel].f.."...")
				arial:print(10, 55,white, "This may take a while. Please Wait!")
				pge.gfx.enddrawing()
				pge.gfx.swapbuffers()
			if pge.net.isconnected() then			
				pge.net.getfile(oth_repo_url.."/"..othlist[cur_oth_sel].f,"ms0:/"..othlist[cur_oth_sel].f)
				pge.gfx.startdrawing()
				pge.gfx.clearscreen()
				
				img_down:activate()
				img_down:draweasy(0,0)
				arial:activate()
				arial:print(10, 40,white, othlist[cur_oth_sel].f.." is installed!")
				arial:print(10, 55,white, "Press Start to Return")

				
				currentwd = pge.dir.getcwd()
				myzipfile = pge.zip.open("ms0:/"..othlist[cur_oth_sel].f)
				pge.dir.chdir("ms0:/")
				myzipfile:extract()
				pge.zip.close(myzipfile)
				myzipfile = nil
									
				pge.dir.chdir(currentwd)
				collectgarbage("collect")
				pge.gfx.enddrawing()
				pge.gfx.swapbuffers()
						
			end
			while not pge.controls.pressed(PGE_CTRL_START) do
				pge.controls.update()
			end
		end
	
		if pge.controls.pressed(PGE_CTRL_CIRCLE) then
			state=21
		end
		if pge.controls.pressed(PGE_CTRL_LTRIGGER) then
			state=1
		end
		if pge.controls.pressed(PGE_CTRL_RTRIGGER) then
			state=3
		end

	end

	if state == 3 then
		img_sear:activate()
		img_sear:draweasy(0,0)
		arial:activate()
		arial:print(120,55,white,"Sorry, The search function has not yet been implemented.")
		if pge.controls.pressed(PGE_CTRL_LTRIGGER) then
			state=2
		end
		if pge.controls.pressed(PGE_CTRL_RTRIGGER) then
			state=4
		end

	end
	if state == 4 then
		img_exit:activate()
		img_exit:draweasy(0,0)
		arial:activate()
		arial:print(120,55,white,"Are you sure you wish to exit PSPInstaller?")
		arial:print(120,70,white,"Press CROSS (X) to Exit.")
		if pge.controls.pressed(PGE_CTRL_CROSS) then
			pge.exit()
		end
		if pge.controls.pressed(PGE_CTRL_LTRIGGER) then
			state=3
		end
	
	end
	if pge.net.isconnected() then
	
	else
		oldstate=state
		state=404
	end
	if state == 404 then
		pge.net.shutdown()
		pge.net.init()
		pge.utils.netinit()

		while pge.running() do
			pge.gfx.startdrawing()
			pge.gfx.clearscreen()
			img_down:activate()
			img_down:draweasy(0,0)
			arial:activate()
			arial:print(10, 40,white, "Wireless Connection Lost.")
		
			
			state2 = pge.utils.netupdate()
			if state2 == 0 then
				pge.gfx.enddrawing()
				state=oldstate
				break
			elseif state2 == 1 then
				pge.net.shutdown()
				break
			elseif state2 ~= PGE_UTILS_DIALOG_RUNNING then
				pge.net.shutdown()
				break
			else
				arial:print(10, 70,white, "PSPInstaller will not work without Wireless! Please Restart!")
				arial:print(10, 85,white, "Press CROSS (X) to Exit.")
				pge.gfx.enddrawing()
				pge.gfx.swapbuffers()
				while not pge.controls.pressed(PGE_CTRL_CROSS) do
					pge.controls.update()
				end
				pge.exit()
			end	
			pge.gfx.enddrawing()
			pge.gfx.swapbuffers()
		end
		
	end
	
	
	pge.gfx.enddrawing()
	pge.gfx.swapbuffers()
	
end
